import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JPasswordField;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.Office.TElOfficeCustomEncryptionHandler;
import SecureBlackbox.Office.TElOfficeOpenXMLAgileEncryptionHandler;
import SecureBlackbox.Office.TElOfficeOpenXMLPasswordKeyEncryptor;
import SecureBlackbox.Office.TElOfficeOpenXMLStandardEncryptionHandler;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;


public class OpenXMLEncOptionsForm extends JDialog {
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbDest;
	private JPasswordField tbPassword;
	private JComboBox<String> cmbEncryptionType;
	private JComboBox<String> cmbEncryptionAlgorithm;
	private JComboBox<String> cmbHashAlgorithm;
	private JSpinner tbSpinCount;
	private JSpinner tbSaltSize;
	private boolean isOk;
	private FileNameExtensionFilter mFilter;
	private JButton btnEncrypt;

	TElOfficeOpenXMLStandardEncryptionHandler _StandardEncryptionHandler = new TElOfficeOpenXMLStandardEncryptionHandler();
	TElOfficeOpenXMLAgileEncryptionHandler _AgileEncryptionHandler = new TElOfficeOpenXMLAgileEncryptionHandler();
	private JLabel lbDest;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			OpenXMLEncOptionsForm dialog = new OpenXMLEncOptionsForm();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public OpenXMLEncOptionsForm() {
		setTitle("Encryption options");
		setBounds(100, 100, 387, 399);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBounds(10, 11, 359, 63);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				lbDest = new JLabel("Destination file");
				lbDest.setBounds(10, 11, 162, 14);
				panel.add(lbDest);
			}
			
			tbDest = new JTextField();
			tbDest.setBounds(10, 28, 238, 20);
			panel.add(tbDest);
			tbDest.setColumns(10);
			
			JButton btnBrowse = new JButton("Browse");
			btnBrowse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					browseClick();
				}
			});
			btnBrowse.setBounds(258, 27, 91, 23);
			panel.add(btnBrowse);
		}
		
		JPanel panel = new JPanel();
		panel.setBounds(10, 85, 359, 238);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JLabel lblEncryptionType = new JLabel("Encryption type");
		lblEncryptionType.setBounds(10, 11, 149, 14);
		panel.add(lblEncryptionType);
		
		cmbEncryptionType = new JComboBox<String>();
		cmbEncryptionType.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				cmbEncryptionType_SelectedIndexChanged(e);
			}
		});
		cmbEncryptionType.setModel(new DefaultComboBoxModel<String>(new String[] {"Standard", "Agile (Office 2007 SP2, 2010)"}));
		cmbEncryptionType.setBounds(169, 7, 180, 22);
		panel.add(cmbEncryptionType);
		
		JLabel lblEncryptionAlgorithm = new JLabel("Encryption Algorithm");
		lblEncryptionAlgorithm.setBounds(10, 44, 117, 14);
		panel.add(lblEncryptionAlgorithm);
		
		cmbEncryptionAlgorithm = new JComboBox<String>();
		cmbEncryptionAlgorithm.setBounds(169, 40, 180, 22);
		panel.add(cmbEncryptionAlgorithm);
		
		JLabel lblHashAlgorithm = new JLabel("Hash Algorithm");
		lblHashAlgorithm.setBounds(10, 80, 117, 14);
		panel.add(lblHashAlgorithm);
		
		cmbHashAlgorithm = new JComboBox<String>();
		cmbHashAlgorithm.setModel(new DefaultComboBoxModel<String>(new String[] {"SHA-1", "SHA-256", "SHA-384", "SHA-512", "MD5", "RIPEMD-160"}));
		cmbHashAlgorithm.setBounds(169, 76, 180, 22);
		panel.add(cmbHashAlgorithm);
		
		JLabel lblSpinCount = new JLabel("Spin Count");
		lblSpinCount.setBounds(10, 120, 117, 14);
		panel.add(lblSpinCount);
		
		tbSpinCount = new JSpinner();
		tbSpinCount.setModel(new SpinnerNumberModel(new Integer(100000), null, null, new Integer(1)));
		tbSpinCount.setBounds(169, 118, 180, 20);
		panel.add(tbSpinCount);
		
		JLabel lblSaltSize = new JLabel("Salt Size");
		lblSaltSize.setBounds(10, 159, 96, 14);
		panel.add(lblSaltSize);
		
		tbSaltSize = new JSpinner();
		tbSaltSize.setModel(new SpinnerNumberModel(new Integer(16), null, null, new Integer(1)));
		tbSaltSize.setBounds(169, 157, 180, 20);
		panel.add(tbSaltSize);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(10, 202, 65, 14);
		panel.add(lblPassword);
		
		tbPassword = new JPasswordField();
		tbPassword.setBounds(169, 199, 180, 20);
		panel.add(tbPassword);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				btnEncrypt = new JButton("Encrypt");
				btnEncrypt.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				btnEncrypt.setActionCommand("OK");
				buttonPane.add(btnEncrypt);
				getRootPane().setDefaultButton(btnEncrypt);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected void cmbEncryptionType_SelectedIndexChanged(ItemEvent e) {
		int i = cmbEncryptionType.getSelectedIndex();
		btnEncrypt.setEnabled(i >= 0);
		tbPassword.setEnabled(i >= 0);
		cmbEncryptionAlgorithm.setEnabled(i >= 0);
		cmbHashAlgorithm.setEnabled(i == 1);
		tbSpinCount.setEnabled(i == 1);
		tbSaltSize.setEnabled(i == 1);
		cmbEncryptionAlgorithm.removeAllItems();
		cmbEncryptionAlgorithm.addItem(SBConstants.getAlgorithmNameByAlgorithm(SBConstants.SB_ALGORITHM_CNT_AES128));
		cmbEncryptionAlgorithm.addItem(SBConstants.getAlgorithmNameByAlgorithm(SBConstants.SB_ALGORITHM_CNT_AES192));
		cmbEncryptionAlgorithm.addItem(SBConstants.getAlgorithmNameByAlgorithm(SBConstants.SB_ALGORITHM_CNT_AES256));
		if (i == 1)
		{
			cmbEncryptionAlgorithm.addItem(SBConstants.getAlgorithmNameByAlgorithm(SBConstants.SB_ALGORITHM_CNT_DES));
			cmbEncryptionAlgorithm.addItem(SBConstants.getAlgorithmNameByAlgorithm(SBConstants.SB_ALGORITHM_CNT_3DES));
			cmbEncryptionAlgorithm.addItem(SBConstants.getAlgorithmNameByAlgorithm(SBConstants.SB_ALGORITHM_CNT_RC2));
			cmbEncryptionAlgorithm.addItem(SBConstants.getAlgorithmNameByAlgorithm(SBConstants.SB_ALGORITHM_CNT_RC4));
		}

		cmbEncryptionAlgorithm.setSelectedIndex(0);
		cmbHashAlgorithm.setSelectedIndex(0);		
	}

	protected void browseClick() {
		String fileName = getOpenFileName();
		if (fileName.length() > 0)
			tbDest.setText(fileName);			
	}
	
	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    
		fc.setFileFilter(mFilter);
	    
		int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}	
	
	public boolean isOK() {
		return isOk;
	}

	public void setSaveDefaultExt(String ext) {
		mFilter = new FileNameExtensionFilter(String.format("Current document type *.%s | All files (*.*)|*.*", ext), ext, "*");
	}

	public TElOfficeCustomEncryptionHandler getEncryptionHandler() {
		int EncryptionAlgorithm;
		switch (cmbEncryptionAlgorithm.getSelectedIndex())
		{
			case 0 : EncryptionAlgorithm = SBConstants.SB_ALGORITHM_CNT_AES128; break;
			case 1 : EncryptionAlgorithm = SBConstants.SB_ALGORITHM_CNT_AES192; break;
			case 2 : EncryptionAlgorithm = SBConstants.SB_ALGORITHM_CNT_AES256; break;
			case 3 : EncryptionAlgorithm = SBConstants.SB_ALGORITHM_CNT_DES; break;
			case 4 : EncryptionAlgorithm = SBConstants.SB_ALGORITHM_CNT_3DES; break;
			case 5 : EncryptionAlgorithm = SBConstants.SB_ALGORITHM_CNT_RC2; break;
			case 6 : EncryptionAlgorithm = SBConstants.SB_ALGORITHM_CNT_RC4; break;
			default:
				EncryptionAlgorithm = SBConstants.SB_ALGORITHM_UNKNOWN; break;
		}

		if (cmbEncryptionType.getSelectedIndex() == 0)
		{
			_StandardEncryptionHandler.reset();
			_StandardEncryptionHandler.setEncryptionAlgorithm(EncryptionAlgorithm);
			_StandardEncryptionHandler.setPassword(new String(tbPassword.getPassword()));
			return _StandardEncryptionHandler;
		}
		else if (cmbEncryptionType.getSelectedIndex() == 1)
		{
			_AgileEncryptionHandler.reset();
			_AgileEncryptionHandler.setCipherAlgorithm(EncryptionAlgorithm);

			switch (cmbHashAlgorithm.getSelectedIndex())
			{
				case 1 : _AgileEncryptionHandler.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_SHA256); break;
				case 2 : _AgileEncryptionHandler.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_SHA384); break;
				case 3 : _AgileEncryptionHandler.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_SHA512); break;
				case 4 : _AgileEncryptionHandler.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_MD5); break;
				case 5 : _AgileEncryptionHandler.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_RIPEMD160); break;
				default : 
					_AgileEncryptionHandler.setHashAlgorithm(SBConstants.SB_ALGORITHM_DGST_SHA1); break;
			}

			
			_AgileEncryptionHandler.setSaltSize(((SpinnerNumberModel)tbSaltSize.getModel()).getNumber().intValue());
			// Note for Office: exactly one password key encryptor MUST be present
			int k = _AgileEncryptionHandler.addPasswordKeyEncryptor(new String(tbPassword.getPassword()));
			TElOfficeOpenXMLPasswordKeyEncryptor PswKeyEnc = (TElOfficeOpenXMLPasswordKeyEncryptor)_AgileEncryptionHandler.getKeyEncryptor(k);
			PswKeyEnc.setCipherAlgorithm(EncryptionAlgorithm);
			PswKeyEnc.setHashAlgorithm(_AgileEncryptionHandler.getHashAlgorithm());
			PswKeyEnc.setSpinCount((int)((SpinnerNumberModel)tbSpinCount.getModel()).getNumber().intValue());
			PswKeyEnc.setSaltSize(_AgileEncryptionHandler.getSaltSize());
			return _AgileEncryptionHandler;
		}
		else
			return null;
	}

	public String getDestText() {
		return tbDest.getText();
	}
}
