import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;

import SecureBlackbox.PGP.TElPGPKeyring;

public class PanelSelectRecipients extends JPanel {
	static final long serialVersionUID = 5190017663301162901L;
	JPanel contentPanel;
	JPanel titlePanel;
	JTable table;
	JLabel pLabel;
	JLabel pcLabel;
	JScrollPane scrollPane;
	JPasswordField password = new JPasswordField();
	JPasswordField cnfmPassword = new JPasswordField();
	
	public PanelSelectRecipients(){
		password.setSize(200, 20);
		password.setLocation(20, 172);
		password.setEnabled(false);
		contentPanel = new JPanel();
		contentPanel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
		setLayout(new BorderLayout());

		JPanel secondaryPanel = new JPanel();
		add(secondaryPanel, BorderLayout.CENTER);
		secondaryPanel.setLayout(null);
		contentPanel = new JPanel();
		contentPanel.setBounds(0, 0, 450, 252);
		secondaryPanel.add(contentPanel);
		contentPanel.setLayout(null);
        JLabel textLabel = new JLabel("<html>Step 4/6<br>Select recipients</html>");
        textLabel.setBackground(Color.gray);
        textLabel.setBorder(new EmptyBorder(new Insets(10, 10, 10, 10)));
        textLabel.setOpaque(true);
        
        titlePanel = new JPanel();
        titlePanel.setLayout(new BorderLayout());
        titlePanel.setBackground(Color.gray);
        titlePanel.add(textLabel, BorderLayout.CENTER);
        add(titlePanel, BorderLayout.NORTH);	
        
		table = new JTable(new KeyTableModel());
		table.setFillsViewportHeight(true);

		scrollPane = new JScrollPane(table);
		scrollPane.setLocation(0, 0);
		scrollPane.setSize(450, 139);
		scrollPane.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		scrollPane.setPreferredSize(new Dimension(585, 200)); 
		
		contentPanel.add(scrollPane);
		
		// passwords
		password.setVisible(false);
		password.setPreferredSize(new Dimension(585, 20));

		cnfmPassword.setSize(200, 20);
		cnfmPassword.setLocation(20, 216);
		
		cnfmPassword.setVisible(false);
		cnfmPassword.setPreferredSize(new Dimension(585, 20));
		
		pLabel = new JLabel("Passphrase for conventional encryption");
		pLabel.setSize(263, 20);
		pLabel.setLocation(20, 152);
		pLabel.setVisible(false);
		contentPanel.add(pLabel);
		contentPanel.add(password);

		pcLabel = new JLabel("Passphrase confirmation");
		pcLabel.setSize(200, 18);
		pcLabel.setLocation(20, 196);
		pcLabel.setVisible(false);
		contentPanel.add(pcLabel);
		contentPanel.add(cnfmPassword);
     
	}

	public void LoadKeys(){
		KeyTableModel model = (KeyTableModel)table.getModel();
		model.init(PanelSelectFiles.getKeys(), true);
		
		if (ProtectionProps.isPassReq())
			showPasswordFields();				
	}
	
	private void showPasswordFields() {
		password.setEnabled(true);
		password.setVisible(true);
		cnfmPassword.setVisible(true);
		pLabel.setVisible(true);
		pcLabel.setVisible(true);
	}

	public boolean isFieldsValidated() {
		if (!password.isEnabled()) return true;
		String s1 = new String(password.getPassword());
		String s2 = new String(cnfmPassword.getPassword());
		if (s1.length() == 0) return false;
		if (s2.length() == 0) return false;
		return (s1.compareTo(s2) == 0);
	}
	
	public void addFieldsListener(final ActionListener l) {
		Common.addPasswordDocumentLisner(password, l);
		Common.addPasswordDocumentLisner(cnfmPassword, l);
	}		
	
	public TElPGPKeyring getKeys(){
		return ((KeyTableModel)table.getModel()).getKeys();
	}
}