import java.util.Vector;

import javax.swing.table.AbstractTableModel;


public class FiltersTableModel extends AbstractTableModel {
	private static final long serialVersionUID = 2771284071470299948L;
	public static final int ATTR_INDEX = 0;
	public static final int EQU_INDEX = 1;
	public static final int VAL_INDEX = 2;
	
	protected Vector<FiltersDataRow> dataVector = new Vector<FiltersDataRow>();
	
    protected String[] columnNames = {
    		"Attribute",
    		"Equality", 
    		"Value" 
    };
    
    public void addRow(String attr, String equ, String val){
    	dataVector.addElement(new FiltersDataRow(attr, equ, val));
    	fireTableDataChanged();
    }
    
	public String getColumnName(int column) {
        return columnNames[column];
    }
    
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
		return dataVector.size();
	}

    public Object getValueAt(int row, int col) {
        FiltersDataRow record = (FiltersDataRow)dataVector.get(row);
        switch (col) {
        	case ATTR_INDEX:
        		return record.Attribute;
        	case EQU_INDEX:
	        	 return record.Equality;
            case VAL_INDEX:
               return record.Value;
            default:
               return new Object();
        }
    }

	public void clear() {
		dataVector.removeAllElements();
	}

	public FiltersDataRow getItem(int i) {
		return dataVector.get(i);
	}
}