

import java.awt.EventQueue;
import java.net.URL;
import java.util.Date;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPasswordField;
import javax.swing.JSeparator;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.JTree;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import SecureBlackbox.Base.*;
import SecureBlackbox.PGP.*;
import SecureBlackbox.PGPLDAP.*;

import java.awt.Dimension;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.event.TreeSelectionListener;
import javax.swing.event.TreeSelectionEvent;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private TElPGPKeyring keyring;
	private JLabel lStatus;
	private JTree tree;
	DefaultMutableTreeNode rootNode;

	private String pubKeyringFile;
	private String secKeyringFile;
	private JPanel pSigInfo;
	private JPanel pKeyInfo;
	private JPanel pUserInfo;
	private JLabel lKeyAlgorithm;
	private JLabel lKeyID;
	private JLabel lKeyFP;
	private JLabel lTimestamp;
	private JLabel lTrust;
	private JLabel lExpires;
	private JLabel picUser;
	private JLabel lUserName;
	private JLabel lSigType;
	private JLabel lSigner;
	private JLabel lSigCreated;
	private JLabel lValidity;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				close();
			}
		});			
		
		setTitle("PGPKeys Demo Application");
		setResizable(false);
		setBounds(100, 100, 743, 485);
		getContentPane().setLayout(null);
		
		JToolBar toolBar = new JToolBar();
		toolBar.setFloatable(false);
		toolBar.setBounds(0, 0, 737, 23);
		getContentPane().add(toolBar);
		
		JButton tNew = new JButton(" ");
		tNew.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				NewKeyring();
			}
		});
		tNew.setSize(new Dimension(20, 20));
		tNew.setIgnoreRepaint(true);
		tNew.setRequestFocusEnabled(false);
		tNew.setFocusable(false);
		tNew.setIcon(getIcon("new"));
		tNew.setFocusPainted(false);
		toolBar.add(tNew);
		
		JButton tLoad = new JButton(" ");
		tLoad.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				LoadKeyring();
			}
		});
		tLoad.setSize(new Dimension(20, 20));
		tLoad.setIgnoreRepaint(true);
		tLoad.setRequestFocusEnabled(false);
		tLoad.setFocusable(false);
		tLoad.setIcon(getIcon("load"));
		tLoad.setFocusPainted(false);
		toolBar.add(tLoad);
		
		JButton tSave = new JButton(" ");
		tSave.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				SaveKeyring();
			}
		});
		tSave.setSize(new Dimension(20, 20));
		tSave.setIgnoreRepaint(true);
		tSave.setRequestFocusEnabled(false);
		tSave.setFocusable(false);
		tSave.setIcon(getIcon("save"));
		tSave.setFocusPainted(false);
		toolBar.add(tSave);
		
		JButton tGenerate = new JButton(" ");
		tGenerate.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				generateKey();
			}
		});
		tGenerate.setSize(new Dimension(20, 20));
		tGenerate.setIgnoreRepaint(true);
		tGenerate.setRequestFocusEnabled(false);
		tGenerate.setFocusable(false);
		tGenerate.setIcon(getIcon("gen"));
		tGenerate.setFocusPainted(false);
		toolBar.add(tGenerate);
		
		JButton tAdd = new JButton(" ");
		tAdd.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				AddKey();
			}
		});
		tAdd.setSize(new Dimension(20, 20));
		tAdd.setIgnoreRepaint(true);
		tAdd.setRequestFocusEnabled(false);
		tAdd.setFocusable(false);
		tAdd.setIcon(getIcon("add"));
		tAdd.setFocusPainted(false);
		toolBar.add(tAdd);
		
		JButton tRemove = new JButton(" ");
		tRemove.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				RemoveKey();
			}
		});
		tRemove.setSize(new Dimension(20, 20));
		tRemove.setIgnoreRepaint(true);
		tRemove.setRequestFocusEnabled(false);
		tRemove.setFocusable(false);
		tRemove.setIcon(getIcon("remove"));
		tRemove.setFocusPainted(false);
		toolBar.add(tRemove);
		
		JButton tExport = new JButton(" ");
		tExport.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				ExportKey();
			}
		});
		tExport.setSize(new Dimension(20, 20));
		tExport.setIgnoreRepaint(true);
		tExport.setRequestFocusEnabled(false);
		tExport.setFocusable(false);
		tExport.setIcon(getIcon("export"));
		tExport.setFocusPainted(false);
		toolBar.add(tExport);
		
		JButton tSign = new JButton(" ");
		tSign.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Sign();
			}
		});
		tSign.setSize(new Dimension(20, 20));
		tSign.setIgnoreRepaint(true);
		tSign.setRequestFocusEnabled(false);
		tSign.setFocusable(false);
		tSign.setIcon(getIcon("sign"));
		tSign.setFocusPainted(false);
		toolBar.add(tSign);
		
		JButton tRevoke = new JButton(" ");
		tRevoke.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Revoke();
			}
		});
		tRevoke.setSize(new Dimension(20, 20));
		tRevoke.setIgnoreRepaint(true);
		tRevoke.setRequestFocusEnabled(false);
		tRevoke.setFocusable(false);
		tRevoke.setIcon(getIcon("revoke"));		
		tRevoke.setFocusPainted(false);
		toolBar.add(tRevoke);
		
		JButton tSend = new JButton(" ");
		tSend.setFocusable(false);
		tSend.setFocusPainted(false);
		tSend.setIcon(getIcon("send"));	
		tSend.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Send();
			}
		});
		toolBar.add(tSend);
		
		JButton tFind = new JButton(" ");
		tFind.setFocusable(false);
		tFind.setFocusPainted(false);
		tFind.setIcon(getIcon("find"));	
		tFind.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				Find();
			}
		});
		toolBar.add(tFind);
		
		rootNode = new DefaultMutableTreeNode();
		tree = new JTree(rootNode);
		tree.addTreeSelectionListener(new TreeSelectionListener() {
			public void valueChanged(TreeSelectionEvent e) {
				treeSelectClick(e);
			}
		});
		tree.setRootVisible(false);
		tree.setShowsRootHandles(true); 		
		tree.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		tree.setBounds(0, 21, 737, 269);
		getContentPane().add(tree);
		
		pKeyInfo = new JPanel();
		pKeyInfo.setBounds(0, 296, 737, 123);
		getContentPane().add(pKeyInfo);
		pKeyInfo.setLayout(null);
		
		lKeyAlgorithm = new JLabel("Algorithm:");
		lKeyAlgorithm.setBounds(36, 11, 320, 14);
		pKeyInfo.add(lKeyAlgorithm);
		
		lKeyID = new JLabel("Key ID:");
		lKeyID.setBounds(36, 36, 320, 14);
		pKeyInfo.add(lKeyID);
		
		lKeyFP = new JLabel("Key FP:");
		lKeyFP.setBounds(36, 61, 320, 14);
		pKeyInfo.add(lKeyFP);
		
		lTimestamp = new JLabel("Created:");
		lTimestamp.setBounds(415, 11, 300, 14);
		pKeyInfo.add(lTimestamp);
		
		lExpires = new JLabel("Expires:");
		lExpires.setBounds(415, 36, 320, 14);
		pKeyInfo.add(lExpires);
		
		lTrust = new JLabel("Trust:");
		lTrust.setBounds(415, 61, 320, 14);
		pKeyInfo.add(lTrust);
		
		pUserInfo = new JPanel();
		pUserInfo.setBounds(442, 296, 290, 112);
		getContentPane().add(pUserInfo);
		pUserInfo.setLayout(null);
		
		lUserName = new JLabel("User name:");
		lUserName.setBounds(10, 11, 280, 14);
		pUserInfo.add(lUserName);
		
		picUser = new JLabel(" ");
		picUser.setBounds(10, 28, 112, 104);
		pUserInfo.add(picUser);
		
		pSigInfo = new JPanel();
		pSigInfo.setBounds(61, 296, 300, 112);
		getContentPane().add(pSigInfo);
		pSigInfo.setLayout(null);
		
		lSigType = new JLabel("Type:");
		lSigType.setBounds(10, 11, 320, 14);
		pSigInfo.add(lSigType);
		
		lSigner = new JLabel("Signer:");
		lSigner.setBounds(10, 36, 320, 14);
		pSigInfo.add(lSigner);
		
		lSigCreated = new JLabel("Created:");
		lSigCreated.setBounds(10, 61, 320, 14);
		pSigInfo.add(lSigCreated);
		
		lValidity = new JLabel("Validity:");
		lValidity.setBounds(10, 86, 320, 14);
		pSigInfo.add(lValidity);
		
		lStatus = new JLabel("Ready");
		lStatus.setBounds(2, 420, 735, 20);
		getContentPane().add(lStatus);
		
		JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);
		
		JMenu mnFile = new JMenu("File");
		menuBar.add(mnFile);
		
		JMenuItem mntmLoadKeyring = new JMenuItem("Load keyring");
		mntmLoadKeyring.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				LoadKeyring();
			}
		});
		mnFile.add(mntmLoadKeyring);
		
		JMenuItem mntmSaveKeyring = new JMenuItem("Save keyring");
		mntmSaveKeyring.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				SaveKeyring();
			}
		});
		mnFile.add(mntmSaveKeyring);
		
		JSeparator separator = new JSeparator();
		mnFile.add(separator);
		
		JMenuItem mntmExit = new JMenuItem("Quit");
		mntmExit.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				close();
			}
		});
		mnFile.add(mntmExit);
		
		JMenu mnHlp = new JMenu("Help");
		menuBar.add(mnHlp);
		
		JMenuItem mntmAb = new JMenuItem("About");
		mntmAb.addMouseListener(new MouseAdapter() {
			@Override
			public void mousePressed(MouseEvent e) {
				AboutDialog d = new AboutDialog();
				d.setModal(true);
				d.setVisible(true);
			}
		});
		mnHlp.add(mntmAb);
		
		init();
	}

	protected void Send() {
		TElPGPPublicKey key;

	    TreePath[] paths = tree.getSelectionPaths();

	    if (paths.length > 0)
	    {
	    	NodeData node = getFirstNode(paths);
	    	
			if (node.getTag() instanceof TElPGPPublicKey)
			{
				key = (TElPGPPublicKey)(node.getTag());
				
				try
				{
					TElLDAPSKeyserverClient cli = new TElLDAPSKeyserverClient();
					cli.setAddress("keyserver.pgp.com");
					cli.setPort(389);
	
					cli.bind();
					cli.add(key);
					cli.unbind();
	
					showMessage("Selected key successfuly uploaded to keyserver.pgp.com", "Result");
				}
				catch (Exception ex)
				{
					showErrorMessage(ex.getMessage(), "Error");
				}
			}
		}
	}

	private void showMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.INFORMATION_MESSAGE);				
	}

	private void Find()
	{
		FindKeyDialog fmFindKey = new FindKeyDialog();
		fmFindKey.setModal(true);
		fmFindKey.setVisible(true);
	}

	protected void treeSelectClick(TreeSelectionEvent e) {
		DefaultMutableTreeNode node = getSelectedNode(e.getPaths());
		NodeData data = (NodeData)node.getUserObject();
		Object tag = data.getTag();
		
		if (tag instanceof TElPGPCustomPublicKey) 
		{
			DrawPublicKeyProps((TElPGPCustomPublicKey)tag);
		} 
		else if (tag instanceof TElPGPUserID) 
		{
			DrawUserIDProps((TElPGPUserID)tag);
		} 
		else if (tag instanceof TElPGPUserAttr) 
		{
			DrawUserAttrProps((TElPGPUserAttr)tag);
		} 
		else if (tag instanceof TElPGPSignature)
		{
			DefaultMutableTreeNode parentNode = (DefaultMutableTreeNode) node.getParent();
			DefaultMutableTreeNode parentParentNode = (DefaultMutableTreeNode) parentNode.getParent();

			NodeData parentData = (NodeData)parentNode.getUserObject();
			NodeData parentParentData = (NodeData)parentParentNode.getUserObject();

			Object parentTag = parentData.getTag();
			Object parentParentTag = parentParentData.getTag();
			
			if ((parentNode != null) && (parentTag instanceof TElPGPCustomUser) &&
				(parentParentNode != null) && (parentParentTag instanceof TElPGPCustomPublicKey)) 
			{
				DrawSignatureProps((TElPGPSignature)tag, (TElPGPCustomUser)parentTag,
					(TElPGPCustomPublicKey)parentParentTag);
			} 
			else if ((parentNode != null) && (parentTag instanceof TElPGPPublicSubkey) &&
				(parentParentNode != null) && (parentParentTag instanceof TElPGPCustomPublicKey)) 
			{
                DrawSignatureProps((TElPGPSignature)tag, (TElPGPPublicSubkey)parentTag,
					(TElPGPCustomPublicKey)parentParentTag);
			}
			else 
			{
				DrawSignatureProps((TElPGPSignature)tag, (TElPGPCustomUser)null, null);
			}
		}		
	}

	@SuppressWarnings("deprecation")
	private void DrawPublicKeyProps(TElPGPCustomPublicKey key)
	{
		HideAllInfoPanels();
		lKeyAlgorithm.setText("Algorithm: " + SBPGPUtils.pkAlg2Str(key.getPublicKeyAlgorithm()) + " (" + key.getBitsInKey() + " bits)");
		lKeyID.setText("KeyID: " + SBPGPUtils.keyID2Str(key.keyID(), false));
		lKeyFP.setText("KeyFP: " + SBPGPUtils.keyFP2Str(key.keyFP()));
		lTimestamp.setText("Created: " + key.getTimeStamp().toString() + " " + key.getTimeStamp());
		if (key.getExpires() == 0) 
		{
			lExpires.setText("Expires: NEVER");
		} 
		else 
		{
			lExpires.setText("Expires: " + key.getTimeStamp().getDay() + key.getExpires());
		}
		pKeyInfo.setVisible(true);
	}

	private void DrawUserIDProps(TElPGPUserID user)
	{
		HideAllInfoPanels();
		picUser.setVisible(false);
		lUserName.setVisible(true);
		lUserName.setText("User name: " + user.getName());
		pUserInfo.setVisible(true);
	}

	private void DrawUserAttrProps(TElPGPUserAttr user)
	{
		TElMemoryStream strm = new TElMemoryStream();
		HideAllInfoPanels();
		picUser.setVisible(true);
		lUserName.setVisible(false);
		strm.write(user.getImage(0).getJpegData(), 0, user.getImage(0).getJpegData().length);
		strm.setPosition(0);
		
		ImageIcon icon = new ImageIcon(strm.getBuffer());
		picUser.setIcon(icon);
		pUserInfo.setVisible(true);
	}

	private void DrawSignatureProps(TElPGPSignature sig, TElPGPCustomUser user,
		TElPGPCustomPublicKey userKey)
	{
		String validity = "Unable to verify";
		HideAllInfoPanels();
		
		TElFindPublicKeyByIDResult result = keyring.findPublicKeyByID(sig.signerKeyID(), 0);
		TElPGPCustomPublicKey key = result.Key;
		
		if (key != null) 
		{
			if (key instanceof TElPGPPublicKey) 
			{
				lSigner.setText("Signer: " + Utils.GetDefaultUserID((TElPGPPublicKey)key));
				if (user != null) 
				{
					try 
					{
						if (sig.isUserRevocation()) 
						{
							if (key.revocationVerify(userKey, user, sig)) 
							{
								validity = "Valid";
							} 
							else 
							{
								validity = "INVALID";
							}
						} 
						else 
						{
							if (key.verify(userKey, user, sig)) 
							{
								validity = "Valid";
							} 
							else 
							{
								validity = "INVALID";
							}
						}
					} 
					catch (Exception ex) 
					{
						validity = ex.getMessage();
					}
				} 
				else 
				{
					validity = "UserID not found";
				}
			}
			else 
			{
				lSigner.setText("Signer: Unknown signer");
			}				
		}  
		else 
		{
			lSigner.setText("Signer: Unknown signer");
		}
		lSigCreated.setText(sig.getCreationTime().toString());
		lValidity.setText("Validity: " + validity);
		if (sig.isUserRevocation()) 
		{
			lSigType.setText("Type: User revocation");
		} 
		else 
		{
			lSigType.setText("Type: Certification signature");
		}
		pSigInfo.setVisible(true);
	}

	private void DrawSignatureProps(TElPGPSignature sig, TElPGPPublicSubkey subkey,
		TElPGPCustomPublicKey userKey) 
	{
		String validity = "Unable to verify";
		HideAllInfoPanels();
		
		lSigner.setText("Signer: " + Utils.GetDefaultUserID((TElPGPPublicKey)userKey));
		if (subkey != null) 
		{
			try 
			{
				if (sig.isSubkeyRevocation()) 
				{
					if (userKey.revocationVerify(subkey, sig)) 
					{
						validity = "Valid";
					} 
					else 
					{
						validity = "INVALID";
					}
				} 
				else 
				{
					if (userKey.verify(subkey, sig)) 
					{
						validity = "Valid";
					} 
					else 
					{
						validity = "INVALID";
					}
				}
			} 
			catch (Exception ex) 
			{
				validity = ex.getMessage();
			}
		} 
		else 
		{
			validity = "Subkey not found";
		}
		lSigCreated.setText(sig.getCreationTime().toString());
		lValidity.setText("Validity: " + validity);
		if (sig.isSubkeyRevocation()) 
		{
			lSigType.setText("Type: Subkey revocation");
		} 
		else 
		{
			lSigType.setText("Type: Subkey binding signature");
		}
		pSigInfo.setVisible(true);
	}
	
	protected void close() {
		keyring.Destroy();
		dispose();
		System.exit(0);
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		keyring = new TElPGPKeyring();
		HideAllInfoPanels();
		Status("Application started");		
	}

	protected void redrawKeyring() {
		Utils.RedrawKeyring(tree, keyring, rootNode);
	}

	protected void Status(String msg) {
		lStatus.setText(msg);
	}

	private Icon getIcon(String name) {
		URL resPath = getClass().getResource(name + ".ico");
		if (resPath == null) return new ImageIcon();
		return new ImageIcon(resPath);
	}
	
	private void generateKey() {
		TElPGPSecretKey key = new TElPGPSecretKey();
		GenerateKeyDialog gd = new GenerateKeyDialog();
		gd.setSecretKey(key);
		gd.setModal(true);
		gd.setVisible(true);
		if (gd.isSuccess()) 
		{
			keyring.addSecretKey(key);
			redrawKeyring();
		}
		Status("New key was added to keyring");				
	}
	
	private void LoadKeyring()
	{
		TElPGPKeyring tempKeyring = new TElPGPKeyring();
		LoadSaveKeyringDialog dlg = new LoadSaveKeyringDialog();
		dlg.setOpenDialog(true);
		dlg.setTitle("Load keyring");
		dlg.setModal(true);
		dlg.setVisible(true);
		if (dlg.isOK()) 
		{
			try 
			{
				tempKeyring.load(dlg.getPublicKeyringText(), dlg.getSecretKeyringText(), true);
			} 
			catch(Exception ex) 
			{
				showErrorMessage(ex.getMessage(), "Keyring error");
				Status("Failed to load keyring");
				return;
			}
			HideAllInfoPanels();
			pubKeyringFile = dlg.getPublicKeyringText();
			secKeyringFile = dlg.getSecretKeyringText();
			keyring.clear();
			tempKeyring.exportTo(keyring);
			redrawKeyring();
			Status("Keyring loaded");
		}
	}

	private void HideAllInfoPanels() {
		pKeyInfo.setVisible(false);
		pUserInfo.setVisible(false);
		pSigInfo.setVisible(false);
	}

	private void showErrorMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);				
	}

	private void SaveKeyring()
	{
		LoadSaveKeyringDialog dlg = new LoadSaveKeyringDialog();
		dlg.setOpenDialog(false);
		dlg.setTitle("Save keyring");
		dlg.setPublicKeyringText(pubKeyringFile);
		dlg.setSecretKeyringText(secKeyringFile);
		dlg.setModal(true);
		dlg.setVisible(true);
		if (dlg.isOK()) { 		
			try 
			{
				keyring.save(dlg.getPublicKeyringText(), dlg.getSecretKeyringText(), false);
				Status("Keyring saved");
			} 
			catch(Exception ex) 
			{
				showErrorMessage(ex.getMessage(), "Keyring error");
				Status("Failed to save keyring");
			}
		}
	}

	private void NewKeyring() 
	{
		if (showConfirmMessage("Are you sure you want to create a new keyring?\nAll unsaved information will be LOST!", "New keyring")) 
		{
			pubKeyringFile = "";
			secKeyringFile = "";
			keyring.clear();
			HideAllInfoPanels();
			redrawKeyring();
			Status("New keyring created");
		}
	}

	private boolean showConfirmMessage(String msg, String cap) {
		return (JOptionPane.showConfirmDialog(this, msg, cap, JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION);
	}

	private void AddKey()
	{
		TElPGPKeyring tempKeyring = new TElPGPKeyring();
		ImportKeyDialog dlg = new ImportKeyDialog();
		String fileName = getOpenFileName();
		if (fileName.length() > 0)
		{
			try 
			{
				tempKeyring.load(fileName, "", true);
			} 
			catch(Exception ex) 
			{
				showErrorMessage(ex.getMessage(), "Unable to load key");
				Status("Failed to import key");
				return;
			}
			dlg.init(tempKeyring);
			dlg.setModal(true);
			dlg.setVisible(true);
			if (dlg.isOK()) 
			{
				tempKeyring.exportTo(keyring);
				redrawKeyring();
			}
		}
		Status(tempKeyring.getPublicCount() + " key(s) successfully imported");
	}

	protected String getOpenFileName() {
		JFileChooser fc = new JFileChooser();
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("PGP files", "pgp");
	    fc.setFileFilter(filter);	
	    
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected String getSaveFileName() {
		JFileChooser fc = new JFileChooser();
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("PGP files", "pgp");
	    fc.setFileFilter(filter);	
	    
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	private void RemoveKey()
	{
		TElPGPPublicKey key;
	    TreePath[] paths = tree.getSelectionPaths();

	    if (paths.length > 0)
	    {
	    	NodeData node = getFirstNode(paths);
	    	
			if (node.getTag() instanceof TElPGPPublicKey)
			{
				key = (TElPGPPublicKey)(node.getTag());
				if (showConfirmMessage("Are you sure you want to remove the key (" + Utils.GetDefaultUserID(key) +
					")?", "Remove key"))
				{
					if (key.getSecretKey() != null) 
					{
						if (showConfirmMessage("The key you want to remove is SECRET! Are you still sure?", "Remove key")) 
						{
							return;
						}
					}
					keyring.removePublicKey(key, true);
					redrawKeyring();
					Status("Key was successfully removed");
				}
			}
	    }
	}

	NodeData getFirstNode(TreePath[] paths){
		return (NodeData)((DefaultMutableTreeNode)paths[0].getLastPathComponent()).getUserObject();
	}

	private DefaultMutableTreeNode getSelectedNode(TreePath[] t) {
		return (DefaultMutableTreeNode)t[0].getLastPathComponent();
	}
	
	private void ExportKey()
	{
		TElPGPPublicKey key;
	    TreePath[] paths = tree.getSelectionPaths();
	    if (paths.length > 0)
	    {
	    	NodeData node = getFirstNode(paths);
	    	
			if (node.getTag() instanceof TElPGPPublicKey)
			{		
				key = (TElPGPPublicKey)node.getTag();
				String fileName = getSaveFileName();
				if (fileName.length() > 0) 
				{
					key.saveToFile(fileName, true);
					Status("Key saved");
				}
			}
		}
	}

	private void Sign()
	{
		SelectKeyDialog dlg = new SelectKeyDialog();
		TElPGPKeyring keys = new TElPGPKeyring();
		TElPGPSignature sig;
		DefaultMutableTreeNode newNode;
		int i;

	    TreePath[] paths = tree.getSelectionPaths();
	    if (paths.length > 0)
	    {
	    	NodeData node = getFirstNode(paths);
	    	
			for(i = 0; i < keyring.getSecretCount(); i++) 
			{
				keys.addSecretKey(keyring.getSecretKeys(i));
			}
			dlg.init(keys);
			if (node.getTag() instanceof TElPGPCustomUser) 
			{
				dlg.setModal(true);
				dlg.setVisible(true);
				if ((dlg.isOK()) && (dlg.getKeysSelectedItemsCount() > 0))
				{
						DefaultMutableTreeNode SelectedNode = getSelectedNode(paths);
						DefaultMutableTreeNode SelectedNodeParent = (DefaultMutableTreeNode) SelectedNode.getParent(); 
						
						if (SelectedNodeParent != null) 
						{
							NodeData nodeParent = (NodeData)SelectedNodeParent.getUserObject();
							if  (nodeParent.getTag() instanceof TElPGPPublicKey)
							{
								Object SelectedNodeTag = ((NodeData)SelectedNode.getUserObject()).getTag();

								sig = SignUser((TElPGPCustomUser)(SelectedNodeTag), 
									(TElPGPPublicKey)(nodeParent.getTag()), 
									(TElPGPSecretKey)(dlg.getKeysSelectedItemsTag(0)));
								if (sig != null) 
								{
			                        ((TElPGPCustomUser)(SelectedNodeTag)).addSignature(sig);
			                        
			                        newNode = new DefaultMutableTreeNode("Signature");
			                        newNode.setUserObject(new NodeData(sig, "Signature", tree.getFont()));
			                        SelectedNode.add(newNode);
			        				
									Status("Signed successfully");
								}
							}
						}
				    }
				} 
			}
			else 
			{
				showErrorMessage("Only User information may be signed",	"Error");
			}
	}

	private void Revoke()
	{
		SelectKeyDialog dlg = new SelectKeyDialog();
		TElPGPKeyring keys = new TElPGPKeyring();
		TElPGPSignature sig;
		DefaultMutableTreeNode newNode;
		int i;

	    TreePath[] paths = tree.getSelectionPaths();
	    if (paths.length > 0)
	    {
	    	NodeData node = getFirstNode(paths);
	    	
			for(i = 0; i < keyring.getSecretCount(); i++) 
			{
				keys.addSecretKey(keyring.getSecretKeys(i));
			}
			dlg.init(keys);
			
			Object SelectedNodeTag = node.getTag();
			DefaultMutableTreeNode SelectedNodeParent = (DefaultMutableTreeNode) getSelectedNode(paths).getParent(); 
			if ((SelectedNodeTag instanceof TElPGPCustomUser) &&
				(SelectedNodeParent != null) &&
				(((NodeData)SelectedNodeParent.getUserObject()).getTag() instanceof TElPGPPublicKey))
			{
				dlg.setModal(true);
				dlg.setVisible(true);
				if ((dlg.isOK()) && (dlg.getKeysSelectedItemsCount() > 0))
				{
					Object SelectedNodeParentTag = ((NodeData)SelectedNodeParent.getUserObject()).getTag();
					sig = RevokeUser((TElPGPCustomUser)(SelectedNodeTag), 
						(TElPGPPublicKey)(SelectedNodeParentTag), 
						(TElPGPSecretKey)(dlg.getKeysSelectedItemsTag(0)));
					if (sig != null) 
					{
                        ((TElPGPCustomUser)(SelectedNodeTag)).addSignature(sig);
                        
            			DefaultMutableTreeNode SelectedNode = getSelectedNode(paths);
                        newNode = new DefaultMutableTreeNode("Revocation");
                        newNode.setUserObject(new NodeData(sig, "Revocation", tree.getFont()));
                        SelectedNode.add(newNode);
                        
						Status("Revoked successfully");
					}
				} 
			}
			else 
			{
				showErrorMessage("Only User signature information may be revoked", "Error");
			}
		}
	}
  
	private TElPGPSignature SignUser(TElPGPCustomUser user, TElPGPCustomPublicKey userKey,
		TElPGPSecretKey signingKey) 
	{
		TElPGPSignature sig = new TElPGPSignature();
		sig.setCreationTime(new Date());
		try 
		{
			signingKey.sign((TElPGPPublicKey)userKey, user, sig, SBPGPKeys.ctGeneric);
		} 
		catch(Exception ex) 
		{
			// Exception. Possibly, pass phrase is needed.
			signingKey.setPassphrase(requestPassphrase(signingKey.getPublicKey()));
			try 
			{
				signingKey.sign((TElPGPPublicKey)userKey, user, sig, SBPGPKeys.ctGeneric);
			} 
			catch(Exception exin) 
			{
				showErrorMessage(exin.getMessage(), "Signing error");
				return null;
			}
		}
		return sig;
	}

	private TElPGPSignature RevokeUser(TElPGPCustomUser user, TElPGPCustomPublicKey userKey,
		TElPGPSecretKey signingKey) 
	{
		TElPGPSignature sig = new TElPGPSignature();
		sig.setCreationTime(new Date());
		try 
		{
			signingKey.revoke((TElPGPPublicKey)userKey, user, sig, null);
		} 
		catch(Exception ex) 
		{
			// Exception. Possibly, pass phrase is needed.
			signingKey.setPassphrase(requestPassphrase(signingKey.getPublicKey()));
			try 
			{
				signingKey.revoke((TElPGPPublicKey)userKey, user, sig, null);
			} 
			catch(Exception exin) 
			{
				showErrorMessage(exin.getMessage(), "Signing error");
				return null;
			}
		}
		return sig;
	}
	

 	private String requestPassword(String msg) {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, msg, JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}

	private String requestPassphrase(TElPGPPublicKey key)
	{
		String msg = Utils.GetDefaultUserID(key) + " (" + SBPGPUtils.keyID2Str(key.keyID(), true) + ")";
        return requestPassword(msg);
	}
}
