

import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.filechooser.FileNameExtensionFilter;

import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JPasswordField;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.util.UUID;

import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.Base.*;
import SecureBlackbox.PDF.*;

public class Main extends JDialog implements ActionListener {
	private static final long serialVersionUID = 506720942061899392L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbSource;
	private JTextField tbDest;
	private JPasswordField tbPassword;
	private JTextField tbCert;
	private JPasswordField tbCertPassword;
	JRadioButton rbPublicKeyEncryption;
	JRadioButton rbPasswordEncryption;	
	JButton btnBrowseCert;
	JCheckBox cbEncryptMetadata;
	JComboBox<String> cbEncryptionAlgorithm;
	JButton btnEncrypt;
	
	JLabel lCert;
	JLabel lCertPassword;
	private TElPDFDocument Document;
	private TElPDFPasswordSecurityHandler PasswordHandler;
	private TElPDFPublicKeySecurityHandler PublicKeyHandler;
	private TElX509Certificate Cert;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {	
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		SBPDF.initialize();
		SBPDFSecurity.initialize();
		
		setTitle("Tiny PDF Encryptor");
		setBounds(100, 100, 436, 441);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblNewLabel = new JLabel("Source PDF File");
		lblNewLabel.setBounds(10, 11, 92, 14);
		contentPanel.add(lblNewLabel);
		
		tbSource = new JTextField();
		tbSource.setBounds(10, 27, 307, 20);
		contentPanel.add(tbSource);
		tbSource.setColumns(10);
		
		JButton btnBrowseSource = new JButton("Browse");
		btnBrowseSource.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbSource.setText(getSourceFile());
			}
		});
		btnBrowseSource.setBounds(327, 26, 91, 23);
		contentPanel.add(btnBrowseSource);
		
		JLabel lblDestinationPdfFile = new JLabel("Destination PDF File");
		lblDestinationPdfFile.setBounds(10, 58, 246, 14);
		contentPanel.add(lblDestinationPdfFile);
		
		tbDest = new JTextField();
		tbDest.setBounds(10, 74, 307, 20);
		contentPanel.add(tbDest);
		tbDest.setColumns(10);
		
		JButton btnBrowseDest = new JButton("Browse");
		btnBrowseDest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbDest.setText(getDestinationFile());
			}
		});
		btnBrowseDest.setBounds(327, 73, 91, 23);
		contentPanel.add(btnBrowseDest);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Encryption properties", TitledBorder.CENTER, TitledBorder.TOP, null, null));
		panel.setBounds(10, 116, 408, 262);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JLabel lblNewLabel_1 = new JLabel("Encryption algorithm");
		lblNewLabel_1.setBounds(10, 25, 187, 14);
		panel.add(lblNewLabel_1);
		
		cbEncryptionAlgorithm = new JComboBox<String>();
		cbEncryptionAlgorithm.setBounds(10, 42, 158, 22);
		cbEncryptionAlgorithm.setModel(new DefaultComboBoxModel<String>(new String[] {"RC4/40 bits (Acrobat 4)", "RC4/128 bits (Acrobat 5)", "AES/128 bits (Acrobat 6, 7)", "AES/256 bits (Acrobat 9)"}));
		panel.add(cbEncryptionAlgorithm);
		
		cbEncryptMetadata = new JCheckBox("Encrypt document metadata");
		cbEncryptMetadata.setBounds(183, 42, 215, 23);
		cbEncryptMetadata.setSelected(true);
		panel.add(cbEncryptMetadata);
		
		rbPasswordEncryption = new JRadioButton("Password encryption");
		rbPasswordEncryption.setBounds(10, 71, 158, 23);
		rbPasswordEncryption.setSelected(true);
		panel.add(rbPasswordEncryption);
		
		tbPassword = new JPasswordField();
		tbPassword.setBounds(20, 95, 135, 20);
		panel.add(tbPassword);
		
		rbPublicKeyEncryption = new JRadioButton("Public key encryption");
		rbPublicKeyEncryption.setBounds(10, 118, 175, 23);
		panel.add(rbPublicKeyEncryption);
		
		ButtonGroup group = new ButtonGroup();
		group.add(rbPublicKeyEncryption);
		group.add(rbPasswordEncryption);
		
		rbPasswordEncryption.addActionListener(this);
		rbPublicKeyEncryption.addActionListener(this);
		
		lCert = new JLabel("Encryption certificate");
		lCert.setBounds(33, 148, 209, 14);
		panel.add(lCert);
		
		tbCert = new JTextField();
		tbCert.setBounds(33, 165, 275, 20);
		panel.add(tbCert);
		tbCert.setColumns(10);
		
		btnBrowseCert = new JButton("Browse");
		btnBrowseCert.setBounds(318, 164, 80, 23);
		btnBrowseCert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbCert.setText(getCertFile());
			}
		});
		panel.add(btnBrowseCert);
		
		lCertPassword = new JLabel("Certificate password");
		lCertPassword.setBounds(33, 196, 135, 14);
		panel.add(lCertPassword);
		
		tbCertPassword = new JPasswordField();
		tbCertPassword.setBounds(33, 214, 135, 20);
		panel.add(tbCertPassword);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				btnEncrypt = new JButton("Encrypt");
				btnEncrypt.setEnabled(false);
				btnEncrypt.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						encrypt();
					}
				});
				btnEncrypt.setActionCommand("OK");
				buttonPane.add(btnEncrypt);
				getRootPane().setDefaultButton(btnEncrypt);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		refreshSelection();
		
		addFieldsListener(this);
	}
	
	public void addFieldsListener(final ActionListener l) {
		addTextDocumentLisner(tbSource, l);
		addTextDocumentLisner(tbDest, l);
	}
	
	public void addTextDocumentLisner(final JTextField txt, final ActionListener l) {
		txt.getDocument().addDocumentListener(new DocumentListener() {
			public void changedUpdate(DocumentEvent e) {
				l.actionPerformed(new ActionEvent(txt, 0, "changed"));
			}

			public void insertUpdate(DocumentEvent arg0) {
				l.actionPerformed(new ActionEvent(txt, 1, "insert"));
			}

			public void removeUpdate(DocumentEvent e) {			
				l.actionPerformed(new ActionEvent(txt, 2, "remove"));
			}
		});
	} 
		
	private void refreshSelection() {
		boolean val = rbPublicKeyEncryption.isSelected();
		tbPassword.setEnabled(!val);
		tbCert.setEnabled(val);
		tbCertPassword.setEnabled(val);
		btnBrowseCert.setEnabled(val);
		lCert.setEnabled(val);
		lCertPassword.setEnabled(val);
	}

	protected String getDestinationFile() {
		JFileChooser fc = new JFileChooser();
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("PDF files", "pdf");
	    fc.setFileFilter(filter);	
	    
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected String getSourceFile() {
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("PDF files", "pdf");
	    fc.setFileFilter(filter);		 
	    
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	protected String getCertFile() {
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("Raw X.509 certificate", "cer", "csr", "crt", "pem", "pfx", "p12");
	    fc.setFileFilter(filter);		 
	    
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
	
	public void actionPerformed(ActionEvent e) {
		refreshSelection();
		if (tbSource.getText().length() > 0 && tbDest.getText().length() > 0)
			btnEncrypt.setEnabled(true);
			
	}
	
	private void encrypt() {
		
		Document = new TElPDFDocument();
		Document.setOwnActivatedSecurityHandlers(true);
		PasswordHandler = new TElPDFPasswordSecurityHandler();
		PublicKeyHandler = new TElPDFPublicKeySecurityHandler();
		Cert = new TElX509Certificate();
		
		boolean Success = false;
		TElPDFSecurityHandler CurrHandler;
		int Alg;
		int KeySize;
		int CertFormat;
		int GroupIndex;
		String TempPath = getTempFileName();

		try 
		{
			// creating a temporary file copy
			copyFile(tbSource.getText(), TempPath, true);
			// opening the temporary file
			TElFileStream F = new TElFileStream(TempPath, "rw", true);
			try 
			{
                Document.open(F);
				try 
				{
					// checking if the document is already encrypted
					if (Document.getEncrypted()) 
					{
						showErrorMessage("Error", "The document is already encrypted");
                        return;
					}
					// checking if the document is signed
					if (Document.getSigned()) 
					{
						showErrorMessage("Error", "The document contains a digital signature and cannot be encrypted");
						return;
					}
					// setting up property values
					if (rbPasswordEncryption.isSelected()) 
						CurrHandler = PasswordHandler;
					else 
                        CurrHandler = PublicKeyHandler;
					// the following encryption handler assignment must be executed before
					// other handler properties are assigned, since encryption handler
					// has to access document properties during its work.
					Document.setEncryptionHandler(CurrHandler);
					CurrHandler.setEncryptMetadata(cbEncryptMetadata.isSelected());
					switch(cbEncryptionAlgorithm.getSelectedIndex()) 
					{
						case 0 :
							Alg = SBConstants.SB_ALGORITHM_CNT_RC4;
							KeySize = 40;
							break;
						case 1 :
							Alg = SBConstants.SB_ALGORITHM_CNT_RC4;
							KeySize = 128;
							break;
						case 2 :
							Alg = SBConstants.SB_ALGORITHM_CNT_AES128;
							// the key size for this cipher is always 128 bits, so we may
							// omit the assignment in this point. However, just to calm the
				            // compiler we assign the 0 value to KeySize variable.
							KeySize = 0;
							break;
						case 3 :
							Alg = SBConstants.SB_ALGORITHM_CNT_AES256;
							// the key size for this cipher is always 256 bits, so we may
							// omit the assignment in this point. However, just to calm the
				            // compiler we assign the 0 value to KeySize variable.
							KeySize = 0;
							break;
						default:
							// normally, we should not reach this point, so just making the
							// compiler silent.
							showErrorMessage("Error", "Unsupported algorithm");
							return;
					}
					// PDF specification allows to use different ciphers for streams and
					// strings contained in a document. However, using the same value for
					// both string and stream encryption allows to achieve greater compatibility
					// with other implementations
					CurrHandler.setStreamEncryptionAlgorithm(Alg);
					CurrHandler.setStringEncryptionAlgorithm(Alg);
					CurrHandler.setStreamEncryptionKeyBits(KeySize);
					CurrHandler.setStringEncryptionKeyBits(KeySize);
					if (CurrHandler instanceof TElPDFPasswordSecurityHandler) 
					{
						PasswordHandler.setUserPassword(new String(tbPassword.getPassword()));
						PasswordHandler.setOwnerPassword(new String(tbPassword.getPassword()));
						PasswordHandler.getPermissions().enableAll();
					} 
					else 
					{
						// loading certificate
						InputStream CertF = new FileInputStream(tbCert.getText());
						try 
						{
							CertFormat = TElX509Certificate.detectCertFileFormat(tbCert.getText());
							switch (CertFormat) 
							{
								case SBX509.cfDER : 
									Cert.loadFromStream(CertF, 0);
									break;
								case SBX509.cfPEM : 
									Cert.loadFromStreamPEM(CertF, new String(tbCertPassword.getPassword()), 0);
									break;
								case SBX509.cfPFX : 
									Cert.loadFromStreamPFX(CertF, new String(tbCertPassword.getPassword()), 0);
									break;
								default:
									showErrorMessage("Error", "Failed to load certificate");
									return;
							} 
						}
						finally 
						{
							CertF.close();
						}
						// creating recipient group
						GroupIndex = PublicKeyHandler.addRecipientGroup();
						// adding recipient certificate to group
						PublicKeyHandler.getRecipientGroup(GroupIndex).addRecipient(Cert);
					}
					// encrypting the document
					Document.encrypt();
					// allowing to save the document
					Success = true;
				} 
				finally 
				{
                    Document.close(Success);
				}
			} 
			finally 
			{
                F.Free();
			}
		} 
		catch(Exception ex) 
		{
			showErrorMessage("Error", "Error: " + ex.getMessage());
			Success = false;
		}
		// if encryption process succeeded, moving the temporary file to the place 
		// of destination file
		if (Success) 
		{
			try {
				copyFile(TempPath, tbDest.getText(), true);
				showMessage("Success", "Encryption process successfully finished");
			} catch (IOException e) {
				showErrorMessage("Error", e.getMessage());
			}
		} 
		else 
		{
			showErrorMessage("Error", "Encryption failed");
		}
		
		// deleting the temporary file
		new File(TempPath).delete();
	}

	static void showErrorMessage(String caption, String msg){
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.ERROR_MESSAGE);
	}
	
	static void showMessage(String caption, String msg) {
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.INFORMATION_MESSAGE);
	}	
	
	private void copyFile(String src, String dest, boolean overwrite) throws IOException {
        RandomAccessFile inputFile = new RandomAccessFile(src, "r");
        RandomAccessFile outputFile = new RandomAccessFile(dest, "rw");
        byte[] buf = new byte[1024];
        int r;
	    
	    if (overwrite)
         outputFile.setLength(0);
	    
        do {
         r = inputFile.read(buf);
         if (r > 0)
          outputFile.write(buf, 0, r);
        } while (r > 0);

        inputFile.close();
        outputFile.close();
	}

	private String getTempFileName() {
		return System.getProperty("java.io.tmpdir") + "/" + UUID.randomUUID().toString();
	}
	
}
