import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.SSHCommon.SBSSHConstants;

public class Globals implements SessionEventListener {

	static private DemoSettings m_Settings = null;
	static private Main m_main = null;
	static private boolean m_ServerStarted = false;
	static private ServerListener m_SSHListener;
	static private SessionEventListener m_eListener;
	
	public static DemoSettings getSettings() {
		return m_Settings;
	}

	public static void setMain(Main main) {
		m_main = main;
	}
	
	public static Main getMain() {
		return m_main;
	}
	
	public static boolean getServerStarted() {
		return m_ServerStarted;
	}
	
	public static void setServerStarted(boolean value) {
		m_ServerStarted = value;
	}
	
	public static ServerListener getSSHListener() {
		return m_SSHListener;
	}
	
	public static void initGlobals(SessionEventListener e){
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		m_Settings = new DemoSettings();
		m_Settings.loadSettings();
		m_eListener = e;
		m_SSHListener = new ServerListener(e);
	}

	public static String AuthTypeToStr(int AuthType)
	{
		switch(AuthType)
		{
			case SBSSHConstants.SSH_AUTH_TYPE_RHOSTS : return "Rhosts";
			case SBSSHConstants.SSH_AUTH_TYPE_PUBLICKEY : return "PublicKey";
			case SBSSHConstants.SSH_AUTH_TYPE_PASSWORD : return "Password";
			case SBSSHConstants.SSH_AUTH_TYPE_HOSTBASED : return "Hostbased";
			case SBSSHConstants.SSH_AUTH_TYPE_KEYBOARD : return "Keyboard-interactive";
			default : return "Unknown";
		}
	}

	public static void StopSSHListener() {
		synchronized (m_SSHListener) {
			try
			{
				m_SSHListener.dispose();
			}
			catch(Exception ex)
			{
			}
			m_SSHListener = new ServerListener(m_eListener);
		}
	}

	public static void StartSSHListener() {
		getSSHListener().start();
	}
	
	public void SessionStarted(SSHSession src) {
		m_eListener.SessionStarted(src);
	}

	public void SessionClosed(SSHSession src) {
		m_eListener.SessionClosed(src);
	}

	public void SessionInfoChanged(SSHSession src) {
		m_eListener.SessionInfoChanged(src);
	}

	public static void mainRun() {
		m_main.setVisible(true);
	}
}
