

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JLabel;
import java.awt.Font;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.SSLClient.*;
import SecureBlackbox.SSLCommon.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.net.InetAddress;
import java.util.Date;


public class Main extends JDialog {
	private static final long serialVersionUID = 1L;
	private JTextField textBoxCert;
	private JTextField textBoxPrivateKey;
	private JTextArea textBoxMemo1;
	private JComboBox<String> comboBox1;
	private JCheckBox cbStrictCertValidation;

	private TElSocket clientSocket = null;
	private TElSSLClient secureClient = null;	
	TSBInteger receiveLen = new TSBInteger();

	private TElX509Certificate clientCert = null;

	private static String sRequest = "GET / HTTP/1.0 \r\n\r\n";
	private TElX509CertificateValidator CertificateValidator;
	private static String sMsgBoxTitle = "SSL Socket Demo";
	private JTextArea textBoxMemo2;
	private JCheckBox checkBoxSSL2;
	private JCheckBox checkBoxSSL3;
	private JCheckBox checkBoxTLS11;
	private JCheckBox checkBoxTLS1;
	private JCheckBox checkBoxTLS12;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("SSL Socket Demo");
		setBounds(100, 100, 606, 485);
		getContentPane().setLayout(null);
		
		JLabel lblHttps = new JLabel("https://");
		lblHttps.setFont(new Font("Tahoma", Font.BOLD, 14));
		lblHttps.setBounds(10, 11, 81, 30);
		getContentPane().add(lblHttps);
		
		comboBox1 = new JComboBox<String>();
		comboBox1.setModel(new DefaultComboBoxModel<String>(new String[] {"www.microsoft.com", "www.order1.net", "www.ibm.com", "www.voebb.de", "oraclestore.oracle.com", "www.sot.com"}));
		comboBox1.setBounds(79, 17, 325, 22);
		getContentPane().add(comboBox1);
		
		JButton btnNonBlockingRequest = new JButton("Non blocking request");
		btnNonBlockingRequest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				nonBlockClick();
			}
		});
		btnNonBlockingRequest.setBounds(414, 3, 177, 23);
		getContentPane().add(btnNonBlockingRequest);
		
		JButton btnBlockingRequest = new JButton("Blocking request");
		btnBlockingRequest.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				blockingClick();
			}
		});
		btnBlockingRequest.setBounds(414, 28, 177, 23);
		getContentPane().add(btnBlockingRequest);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "SSL Options", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 62, 105, 128);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		checkBoxSSL2 = new JCheckBox("SSL2");
		checkBoxSSL2.setBounds(6, 20, 93, 23);
		panel.add(checkBoxSSL2);
		
		checkBoxSSL3 = new JCheckBox("SSL3");
		checkBoxSSL3.setBounds(6, 40, 93, 23);
		panel.add(checkBoxSSL3);
		
		checkBoxTLS1 = new JCheckBox("TLS1");
		checkBoxTLS1.setSelected(true);
		checkBoxTLS1.setBounds(6, 60, 93, 23);
		panel.add(checkBoxTLS1);
		
		checkBoxTLS11 = new JCheckBox("TLS1.1");
		checkBoxTLS11.setSelected(true);
		checkBoxTLS11.setBounds(6, 80, 93, 23);
		panel.add(checkBoxTLS11);
		
		checkBoxTLS12 = new JCheckBox("TLS1.2");
		checkBoxTLS12.setSelected(true);
		checkBoxTLS12.setBounds(6, 100, 93, 23);
		panel.add(checkBoxTLS12);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, "Client certificate (if needed)", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(124, 60, 467, 128);
		getContentPane().add(panel_1);
		panel_1.setLayout(null);
		
		JButton btnCertificate = new JButton("Certificate");
		btnCertificate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				textBoxCert.setText(getOpenFileName());
			}
		});
		btnCertificate.setBounds(10, 23, 107, 23);
		panel_1.add(btnCertificate);
		
		JButton btnNewButton = new JButton("Private key");
		btnNewButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				textBoxPrivateKey.setText(getOpenFileName());
			}
		});
		btnNewButton.setBounds(10, 51, 107, 23);
		panel_1.add(btnNewButton);
		
		cbStrictCertValidation = new JCheckBox("Strict certificate validation");
		cbStrictCertValidation.setBounds(10, 98, 205, 23);
		panel_1.add(cbStrictCertValidation);
		
		textBoxCert = new JTextField();
		textBoxCert.setBounds(127, 24, 330, 20);
		panel_1.add(textBoxCert);
		textBoxCert.setColumns(10);
		
		textBoxPrivateKey = new JTextField();
		textBoxPrivateKey.setColumns(10);
		textBoxPrivateKey.setBounds(127, 52, 330, 20);
		panel_1.add(textBoxPrivateKey);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 201, 578, 139);
		getContentPane().add(scrollPane);
		
		textBoxMemo1 = new JTextArea();
		textBoxMemo1.setLineWrap(true);
		textBoxMemo1.setWrapStyleWord(true);
		scrollPane.setViewportView(textBoxMemo1);
		textBoxMemo1.setColumns(10);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(10, 351, 467, 80);
		getContentPane().add(scrollPane_1);
		
		textBoxMemo2 = new JTextArea();
		scrollPane_1.setViewportView(textBoxMemo2);
		
		JButton btnNewButton_1 = new JButton("Close");
		btnNewButton_1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				reset();
				dispose();
			}
		});
		btnNewButton_1.setBounds(487, 351, 101, 80);
		getContentPane().add(btnNewButton_1);
		
		init();
	}
	
	String getOpenFileName(){
		JFileChooser fc = new JFileChooser();
	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

		return "";
	} 	
	
	protected void blockingClick() {
		reset();
		textBoxMemo1.setText("");
		textBoxMemo2.setText("");

		loadClientCert();

		setSecureClientVersions();

		try
		{
			String addrStr  = (String)comboBox1.getSelectedItem();

			int port = 443; 
			TElParseURLResult res = SBStrUtils.parseURL(addrStr, false);
			secureClient.setEnabled(res.Protocol.compareTo("http://") != 0);
			if (port == 0)
			{
				if (res.Protocol.compareTo("http://") != 0)
					port = 443;
				else
					port = 80;
			}
			
			InetAddress addr = InetAddress.getByName(addrStr);
			addrStr = addr.getHostAddress();
			
			clientSocket = new TElSocket();
			clientSocket.setAddress(addrStr);
			clientSocket.setPort(port);
			if (clientSocket.connect(10000) == 0)
			{
				secureClient.open();
				java.lang.Thread t = new java.lang.Thread(new Runnable() {
					
					public void run() {
						BlockedSocketReceiverThread();
					}
				});
				
				t.start();
			} else {
				showErrorMessage("Can not connect to remote host", "Error");
			}
		}
		catch(Exception ex)
		{
			if (clientSocket != null)
				showErrorMessage("Unable to connect to host - " + ex.getMessage(), sMsgBoxTitle);
		}
	}

	private void BlockedSocketReceiverThread()
	{
		try
		{
			while (true)
			{
				if (clientSocket.canReceive(10))
					secureClient.dataAvailable();
			}
		}
		catch(Exception ex)
		{
			if (clientSocket != null)
				showErrorMessage("Exception when receive data - " + ex.getMessage(), "Error");
		}
	}
	
	private void setSecureClientVersions()
	{
		secureClient.setVersions((short) 0);
        if (checkBoxSSL2.isSelected())
			secureClient.setVersions((byte)((byte)secureClient.getVersions() | SBSSLConstants.sbSSL2));
		if (checkBoxSSL3.isSelected())
			secureClient.setVersions((byte)((byte)secureClient.getVersions() | SBSSLConstants.sbSSL3));
		if (checkBoxTLS1.isSelected())
			secureClient.setVersions((byte)((byte)secureClient.getVersions() | SBSSLConstants.sbTLS1));
		if (checkBoxTLS11.isSelected())
			secureClient.setVersions((byte)((byte)secureClient.getVersions() | SBSSLConstants.sbTLS11));
		if (checkBoxTLS12.isSelected())
			secureClient.setVersions((byte)((byte)secureClient.getVersions() | SBSSLConstants.sbTLS12));
	}

	
	protected void nonBlockClick() {
		reset();
        textBoxMemo1.setText("");
		textBoxMemo2.setText("");

		loadClientCert();

		setSecureClientVersions();

		try
		{
			String addrStr  = (String)comboBox1.getSelectedItem();
			
			int port = 443; 
			TElParseURLResult res = SBStrUtils.parseURL(addrStr, false);
			secureClient.setEnabled(res.Protocol.compareTo("http://") != 0);
			if (port == 0)
			{
				if (res.Protocol.compareTo("http://") != 0)
					port = 443;
				else
					port = 80;
			}

			InetAddress addr = InetAddress.getByName(addrStr);
			addrStr = addr.getHostAddress();
			
			clientSocket = new TElSocket();
			clientSocket.setAddress(addrStr);
			clientSocket.setPort(port);
			
			beginConnect();
			
		}
		catch(Exception ex)
		{
			if (clientSocket != null)
				showErrorMessage("Unable to connect to host - " + ex.getMessage(), sMsgBoxTitle);
		}
	}

	private void showErrorMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);
	}

	private void beginConnect() {
		try
		{
	  		if (clientSocket.connect(5000) == 0) {
				secureClient.open();
							
				java.lang.Thread t = new  java.lang.Thread(new Runnable() {
					
					public void run() {
						beginReceive();			
					}
				});
				
				t.start();
	  		} else {
	  			showErrorMessage("Failed to connect socket to the port", "Error");
	  		}
		}
		catch(Exception ex)
		{
			clientSocket.close(false);
			clientSocket = null;
			showErrorMessage(ex);
			return;
		}
	}

	private void beginReceive() {
		try
		{
			while (true)
			{
				if (clientSocket.canReceive(10))
					secureClient.dataAvailable();
			}
		}
		catch(Exception ex)
		{
			if (clientSocket != null)
				showErrorMessage("Exception when receive data - " + ex.getMessage(), "Error");
		}		
	}

	private void showErrorMessage(Exception ex) {
		showErrorMessage(ex.getMessage(), "Error");
	}
	
	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
		
		secureClient = new TElSSLClient(null);	
		secureClient.setEnabled(true);

		secureClient.setOnOpenConnection(new TSBOpenConnectionEvent(SecureClientOpenConnection));
		secureClient.setOnCloseConnection(new TSBCloseConnectionEvent(SecureClientCloseConnection));
		secureClient.setOnData(new TSBDataEvent(SecureClientOnData));
		secureClient.setOnSend(new TSBSendEvent(SecureClientSend));
		secureClient.setOnReceive(new TSBReceiveEvent(SecureClientReceive));
		secureClient.setOnCertificateNeeded(new TSBCertificateNeededEvent(SecureClientCertificateNeeded));
		secureClient.setOnCertificateValidate(new TSBCertificateValidateEvent(SecureClientCertificateValidate));
		secureClient.setOnError(new TSBErrorEvent(SecureClientOnError));
	}
	
	TSBErrorEvent.Callback SecureClientOnError = new TSBErrorEvent.Callback() {
		
		public void tsbErrorEventCallback(TObject sender, int errCode, boolean arg2,
				boolean arg3) {
			showErrorMessage("SecureClient Error Code: " + errCode, "Error");
		}
	};
	
	TSBOpenConnectionEvent.Callback SecureClientOpenConnection = new TSBOpenConnectionEvent.Callback() {
		
		public void tsbOpenConnectionEventCallback(TObject sender) {
			byte[] b = sRequest.getBytes();
			secureClient.sendData(b);
		}
	};
	
	TSBCloseConnectionEvent.Callback SecureClientCloseConnection = new TSBCloseConnectionEvent.Callback() {
		
		public void tsbCloseConnectionEventCallback(TObject sender,
				TSBCloseReason reason) {
			showMessage("Connection closed", sMsgBoxTitle);
			reset();
		}
	};
	
	TSBDataEvent.Callback SecureClientOnData = new TSBDataEvent.Callback() {
		
		public void tsbDataEventCallback(TObject sender, byte[] buffer) {
			String s = new String(buffer);
			textBoxMemo1.setText(textBoxMemo1.getText() + s);
		}
	};
	
	TSBSendEvent.Callback SecureClientSend = new TSBSendEvent.Callback() {
		
		public void tsbSendEventCallback(TObject sender, byte[] buffer) {		
			try
			{	
				if (clientSocket != null) {
					if (buffer.length > 0) {
						TSBInteger sent = new TSBInteger();
						clientSocket.send(buffer, 0, buffer.length, sent);
					}
				}
			}
			catch (Exception ex)
			{
				if (clientSocket != null)
					showErrorMessage("Unable to send data - " + ex.getMessage(), "Error");
			}			
		}
	};
	
	TSBReceiveEvent.Callback SecureClientReceive = new TSBReceiveEvent.Callback() {
		
		public void tsbReceiveEventCallback(TObject sender, byte[] buffer, int maxSize, TSBInteger written) {		
			try
			{
				int err = clientSocket.receive(buffer, maxSize, written);
				if (err != 0)
					written.value = 0;
			}
			catch (Exception ex)
			{
				written.value = 0;
			}
			
		}
	};
	
	TSBCertificateNeededEvent.Callback SecureClientCertificateNeeded = new TSBCertificateNeededEvent.Callback() {
		
		public void tsbCertificateNeededEventCallback(TObject sender,
				TElCertificateNeededEventParams params, TClientCertificateType ClientCertificateType) {
			params.PrivateKeySize = 0;
			params.CertificateSize = 0;
			TElFileStream fs = null;
			
			if (clientCert != null)
			{
				params.CertificateSize = clientCert.getCertificateSize();
				params.CertificateBuffer = new byte[params.CertificateSize];
				SBUtils.sbMove(clientCert.getCertificateBinary(), 0, params.CertificateBuffer, 0, params.CertificateSize);
				TSBInteger pks = new TSBInteger();
				pks.value = params.PrivateKeySize;
				clientCert.saveKeyToBuffer(params.PrivateKeyBuffer, pks);
				params.PrivateKeyBuffer = new byte[params.PrivateKeySize];
				clientCert.saveKeyToBuffer(params.PrivateKeyBuffer, pks);
			}
			else
			if (textBoxCert.getText().length() > 0)
			{
				try
				{
					fs = new TElFileStream(textBoxCert.getText(), "r", true);
					params.CertificateSize = (int)new File(textBoxCert.getText()).length();
					params.CertificateBuffer = new byte[params.CertificateSize];
					fs.read(params.CertificateBuffer, 0, params.CertificateSize);
					fs.Free();
				}
				catch (Exception e)
				{
					showErrorMessage("Failed to load certificate: " + e.getMessage(), 
						sMsgBoxTitle);
					params.CertificateBuffer = new byte[0];
					params.CertificateSize = 0;
				}

				try
				{
					fs = new TElFileStream(textBoxPrivateKey.getText(), "r", true);
					params.PrivateKeySize = (int)new File(textBoxPrivateKey.getText()).length();
					params.PrivateKeyBuffer = new byte[params.PrivateKeySize];
					fs.read(params.PrivateKeyBuffer, 0, params.PrivateKeySize);
					fs.Free();
				}
				catch (Exception e)
				{
					showErrorMessage("Failed to load certificate: " + e.getMessage(), 
						sMsgBoxTitle);
					params.PrivateKeyBuffer = new byte[0];
					params.PrivateKeySize = 0;
				}
			}			
		}
	};
		
	TSBCertificateValidateEvent.Callback SecureClientCertificateValidate = new TSBCertificateValidateEvent.Callback() {
		
		public void tsbCertificateValidateEventCallback(TObject sender,
				TElX509Certificate Certificate, TSBBoolean accept) {
			accept.value = false;
			if ((cbStrictCertValidation.isSelected()) && ((Certificate.getChain() == null) || (Certificate.getChain().getCertificate(0) == Certificate)))
			{
				// For proper CRL and OCSP validation please read instructions in 
				// description of ElX509CertificateValidator class in the help file
				TElX509CertificateValidatorResult vres = new TElX509CertificateValidatorResult();
				CertificateValidator.validateForSSL(Certificate, clientSocket.getRemoteAddress(), clientSocket.getRemoteAddress(), TSBHostRole.hrServer, null, false, new Date(), vres);
				accept.value = (vres.Validity == TSBCertificateValidity.cvOk);
			}
			else
				accept.value = true;
			
		}
	};

	protected void reset() {
		if (secureClient.getActive())
			secureClient.close(false);

		if (clientSocket != null)
		{
			clientSocket.Free();
			clientSocket = null;
		}
	}
	
	protected void showMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.INFORMATION_MESSAGE);
	}

	private void loadClientCert()
	{
		clientCert = null;
		String certName = textBoxCert.getText();
		int extPos = certName.lastIndexOf(".");
		String ext = extPos < 0 ? "" : certName.substring(extPos, certName.length() - extPos);
		if (extPos > -1 && (ext.toLowerCase().compareTo(".p12") == 0 || ext.toLowerCase().compareTo(".pfx") == 0))
		{
			TElFileStream stream = new TElFileStream(certName, "r", true);
			try
			{
				clientCert = new TElX509Certificate();
				int loadError = clientCert.loadFromStreamPFX(stream, textBoxPrivateKey.getText(), (int) stream.getLength());
				if (loadError == 0)
				{
					if (!clientCert.getPrivateKeyExists())
						loadError = 1;
				}
			}
			finally
			{
				stream.Free();
			}
		}		
		else
		if (extPos > -1 && (ext.toLowerCase().compareTo(".pem") == 0))
		{
			TElFileStream stream = new TElFileStream(certName, "r", true);
			try
			{
				clientCert = new TElX509Certificate();
				clientCert.loadFromStreamPEM(stream, textBoxPrivateKey.getText(), (int) stream.getLength());						
			}
			finally
			{
				stream.Free();
			}
		}
	}
	
}
