import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.border.EmptyBorder;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.border.TitledBorder;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.io.FileInputStream;

import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.Base.SBConstants;
import SecureBlackbox.Base.SBStrUtils;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.SBX509;
import SecureBlackbox.Base.TElCustomCertStorage;
import SecureBlackbox.Base.TElMemoryCertStorage;
import SecureBlackbox.Base.TElRelativeDistinguishedName;
import SecureBlackbox.Base.TElX509Certificate;
import SecureBlackbox.XMLSecurity.TElXMLCertIDList;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;


public class XAdESDialog extends JDialog {
	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edDescription;
	private JTextField edDocumentationReference;
	private JTextField edIdentifier;
	private JTextField edCountry;
	private JTextField edPostalCode;
	private JTextField edStateOrProvince;
	private JTextField edCity;
	private JTable table;
	private JTextField edTimestampServer;
	private JCheckBox cbXAdES;
	private JComboBox<String> cmbVersion;
	private JCheckBox cbProductionPlace;
	private JCheckBox cbTimestamp;
	private boolean FVerify;
	private JButton btnAdd;
	private JButton btnRemove;
	private JLabel lbSignedTime;
	private JLabel lbTimestamp;
	private JLabel lbTimestampSerial;
	private TElCustomCertStorage FCertStorage;
	private TElXMLCertIDList FCertIDs;
	private JLabel lblCountry;
	private JLabel lblPostalCode;
	private JLabel lblStateOrProvince;
	private JLabel lblCity;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			XAdESDialog dialog = new XAdESDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public XAdESDialog() {
        FCertStorage = new TElMemoryCertStorage();

		setTitle("XAdES Options");
		setBounds(100, 100, 450, 639);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			cbXAdES = new JCheckBox("Enable XAdES options");
			cbXAdES.setBounds(10, 7, 208, 23);
			contentPanel.add(cbXAdES);
		}
		
		cmbVersion = new JComboBox<String>();
		cmbVersion.setModel(new DefaultComboBoxModel<String>(new String[] {"1.1.1", "1.2.2", "1.3.2"}));
		cmbVersion.setBounds(338, 7, 94, 22);
		contentPanel.add(cmbVersion);
		
		JLabel lblVersion = new JLabel("Version");
		lblVersion.setBounds(275, 11, 53, 14);
		contentPanel.add(lblVersion);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Policy Id", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 37, 422, 113);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		JLabel lblDescription = new JLabel("Description");
		lblDescription.setBounds(10, 30, 90, 14);
		panel.add(lblDescription);
		
		JLabel lblDocumentationReference = new JLabel("Documentation Reference");
		lblDocumentationReference.setBounds(10, 55, 157, 14);
		panel.add(lblDocumentationReference);
		
		JLabel lblIdentifier = new JLabel("Identifier");
		lblIdentifier.setBounds(10, 80, 125, 14);
		panel.add(lblIdentifier);
		
		edDescription = new JTextField();
		edDescription.setBounds(160, 27, 252, 20);
		panel.add(edDescription);
		edDescription.setColumns(10);
		
		edDocumentationReference = new JTextField();
		edDocumentationReference.setBounds(160, 52, 252, 20);
		panel.add(edDocumentationReference);
		edDocumentationReference.setColumns(10);
		
		edIdentifier = new JTextField();
		edIdentifier.setBounds(160, 80, 252, 20);
		panel.add(edIdentifier);
		edIdentifier.setColumns(10);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, "", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(10, 157, 422, 143);
		contentPanel.add(panel_1);
		panel_1.setLayout(null);
		
		cbProductionPlace = new JCheckBox("Production place");
		cbProductionPlace.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				prodactionChanged();
			}
		});
		cbProductionPlace.setBounds(6, 7, 142, 23);
		panel_1.add(cbProductionPlace);
		
		lblCountry = new JLabel("Country");
		lblCountry.setBounds(16, 37, 59, 14);
		panel_1.add(lblCountry);
		
		lblPostalCode = new JLabel("Postal Code");
		lblPostalCode.setBounds(16, 62, 81, 14);
		panel_1.add(lblPostalCode);
		
		lblStateOrProvince = new JLabel("State or Province");
		lblStateOrProvince.setBounds(16, 87, 115, 14);
		panel_1.add(lblStateOrProvince);
		
		lblCity = new JLabel("City");
		lblCity.setBounds(16, 112, 59, 14);
		panel_1.add(lblCity);
		
		edCountry = new JTextField();
		edCountry.setBounds(160, 34, 252, 20);
		panel_1.add(edCountry);
		edCountry.setColumns(10);
		
		edPostalCode = new JTextField();
		edPostalCode.setBounds(159, 59, 253, 20);
		panel_1.add(edPostalCode);
		edPostalCode.setColumns(10);
		
		edStateOrProvince = new JTextField();
		edStateOrProvince.setBounds(160, 84, 252, 20);
		panel_1.add(edStateOrProvince);
		edStateOrProvince.setColumns(10);
		
		edCity = new JTextField();
		edCity.setBounds(160, 109, 252, 20);
		panel_1.add(edCity);
		edCity.setColumns(10);
		
		JPanel panel_2 = new JPanel();
		panel_2.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Signing Certificate's", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_2.setBounds(10, 311, 422, 148);
		contentPanel.add(panel_2);
		panel_2.setLayout(null);
		
		btnAdd = new JButton("Add");
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				addClick();
			}
		});
		btnAdd.setBounds(321, 51, 91, 23);
		panel_2.add(btnAdd);
		
		btnRemove = new JButton("Remove");
		btnRemove.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeClick();
			}
		});
		btnRemove.setBounds(321, 85, 91, 23);
		panel_2.add(btnRemove);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 21, 302, 116);
		panel_2.add(scrollPane);
		
		table = new JTable();
		table.setModel(new DefaultTableModel(
			new Object[][] {
			},
			new String[] {
				"Serial", "Issuer"
			}
		));
		table.setFillsViewportHeight(true);
		scrollPane.setViewportView(table);
		
		JPanel panelInfo = new JPanel();
		panelInfo.setVisible(false);
		panelInfo.setBounds(10, 470, 422, 98);
		contentPanel.add(panelInfo);
		panelInfo.setLayout(null);
		
		JLabel lblSignedTime = new JLabel("Signed Time:");
		lblSignedTime.setBounds(10, 11, 95, 14);
		panelInfo.add(lblSignedTime);
		
		JLabel lblTimestamp = new JLabel("Timestamp:");
		lblTimestamp.setBounds(10, 36, 95, 14);
		panelInfo.add(lblTimestamp);
		
		JLabel lblTimestampSerial = new JLabel("Timestamp Serial:");
		lblTimestampSerial.setBounds(10, 61, 115, 14);
		panelInfo.add(lblTimestampSerial);
		
		lbSignedTime = new JLabel(" ");
		lbSignedTime.setBounds(115, 11, 297, 14);
		panelInfo.add(lbSignedTime);
		
		lbTimestamp = new JLabel(" ");
		lbTimestamp.setBounds(115, 36, 297, 14);
		panelInfo.add(lbTimestamp);
		
		lbTimestampSerial = new JLabel(" ");
		lbTimestampSerial.setBounds(115, 61, 297, 14);
		panelInfo.add(lbTimestampSerial);
		
		JPanel panelTime = new JPanel();
		panelTime.setBounds(10, 470, 442, 98);
		contentPanel.add(panelTime);
		panelTime.setLayout(null);
		
		cbTimestamp = new JCheckBox("Request a timestamp from TSA server");
		cbTimestamp.setBounds(6, 7, 334, 23);
		panelTime.add(cbTimestamp);
		
		edTimestampServer = new JTextField();
		edTimestampServer.setText("http://");
		edTimestampServer.setBounds(10, 37, 402, 20);
		panelTime.add(edTimestampServer);
		edTimestampServer.setColumns(10);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.setActionCommand("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	protected void prodactionChanged() {
        Boolean Enable = cbProductionPlace.isSelected();
        edCountry.setEnabled(Enable);
        lblCountry.setEnabled(Enable);
        edPostalCode.setEnabled(Enable);
        lblPostalCode.setEnabled(Enable);
        edStateOrProvince.setEnabled(Enable);
        lblStateOrProvince.setEnabled(Enable);
        edCity.setEnabled(Enable);
        lblCity.setEnabled(Enable);
	}

	protected void removeClick() {
		((DefaultTableModel)table.getModel()).removeRow(table.getSelectedRow());
	}

	String getFileName(){
		JFileChooser fc = new JFileChooser();

		FileNameExtensionFilter filter = new FileNameExtensionFilter("( PEM | DER | PFX )-encoded certificate", "pem", "cer", "pfx");
	    fc.setFileFilter(filter);	

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}
    
	protected void addClick() {
		String fileName = getFileName();
        if (fileName.length() > 0)
        {	
            TElX509Certificate Cert = new TElX509Certificate();
        	try
            {
            	int length = (int) new File(fileName).length();
            	FileInputStream F = new FileInputStream(fileName);

            	int CertFormat = TElX509Certificate.detectCertFileFormat(fileName);
           	
                if (CertFormat == SBX509.cfDER)
                {
                    Cert.loadFromStream(F, length);
                    FCertStorage.add(Cert, true);
                }
                else if (CertFormat == SBX509.cfPEM)
                {
                    Cert.loadFromStreamPEM(F, requestPassword(), length);
                    FCertStorage.add(Cert, true);
                }
                else if (CertFormat == SBX509.cfPFX)
                {
                    Cert.loadFromStreamPFX(F, requestPassword(), length);
                    FCertStorage.add(Cert, true);
                }
                else
                    showErrorMessage("Failed to load certificate");
                
                F.close();
            }
            catch(Exception ex)
            {
                Cert.Destroy();
            }
        }

        updateCertificates();
	}
	
	static void showErrorMessage(String msg){
		JOptionPane.showMessageDialog(null, msg, "Error", JOptionPane.ERROR_MESSAGE);
	}

    private String requestPassword() {
		JPasswordField jpf = new JPasswordField();
		int result = JOptionPane.showConfirmDialog(null, jpf, "Please enter password", JOptionPane.OK_CANCEL_OPTION);
		if (result == 0)
			return new String(jpf.getPassword());
		return "";
	}
	
	public boolean getIsEnabled() {
		return cbXAdES.isSelected();
	}

	public int getVersionSelectedIndex() {
		return cmbVersion.getSelectedIndex();
	}

	public String getDocumentationReferenceText() {
		return edDocumentationReference.getText();
	}

	public String getDescription() {
		return edDescription.getText();
	}

	public String getIdentifierText() {
		return edIdentifier.getText();
	}

	public boolean getProductionPlaceChecked() {
		return cbProductionPlace.isSelected();
	}

	public String getCityText() {
		return edCity.getText();
	}

	public String getStateOrProvinceText() {
		return edStateOrProvince.getText();
	}

	public String getPostalCodeText() {
		return edPostalCode.getText();
	}

	public String getCountryText() {
		return edCountry.getText();
	}

	public boolean getTimestampChecked() {
		return cbTimestamp.isSelected();
	}

	public String getTimestampServerText() {
		return edTimestampServer.getText();
	}

	public void setChecked(boolean b) {
		cbXAdES.setSelected(b);
	}

	public void setVersionSelectedIndex(int i) {
		cmbVersion.setSelectedIndex(i);
	}

	public void setDescriptionText(String value) {
		edDescription.setText(value);
	}

	public void setDocumentationReferenceText(String value) {
		edDocumentationReference.setText(value);
	}

	public void setIdentifierText(String value) {
		edIdentifier.setText(value);
	}

	public void setProductionPlaceChecked(boolean b) {
		cbProductionPlace.setSelected(b);
	}

	public void setCountryText(String value) {
		edCountry.setText(value);
	}

	public void setStateOrProvinceText(String value) {
		edStateOrProvince.setText(value);
	}

	public void setPostalCodeText(String value) {
		edPostalCode.setText(value);
	}

	public void setCityText(String value) {
		edCity.setText(value);
	}

	public void setSignedTimeText(String value) {
		lbSignedTime.setText(value);
	}

	public void setTimestampText(String value) {
		lbTimestamp.setText(value);
	}

	public void setTimestampSerialText(String value) {
		lbTimestampSerial.setText(value);
	}

	public void setVerify(boolean value) {
        FVerify = value;
        cbTimestamp.setVisible(!value);
        edTimestampServer.setVisible(!value);
        btnAdd.setEnabled(!value);
        btnRemove.setEnabled(!value);

        lbSignedTime.setVisible(value);
        lbTimestamp.setVisible(value);
        lbTimestampSerial.setVisible(value);
        updateCertificates();
	}
	
	private void updateCertificates() {
        clearSigningCertificatesTable();
        if (!FVerify)
            for (int i = 0; i < FCertStorage.getCount(); i++)
            {
                String s = getOIDValue(FCertStorage.getCertificate(i).getIssuerRDN(), SBConstants.SB_CERT_OID_COMMON_NAME.Data);
                if (s == "")
                    s = getOIDValue(FCertStorage.getCertificate(i).getIssuerRDN(), SBConstants.SB_CERT_OID_ORGANIZATION.Data);

                if (s == "")
                    s = "<unknown>";

                byte[] B = FCertStorage.getCertificate(i).getSerialNumber();
                addSignCertItem(SBUtils.beautifyBinaryString(SBUtils.binaryToString(B), ' '), s, FCertStorage.getCertificate(i));
            }
        else
            if (FCertIDs != null)
                for (int i = 0; i < FCertIDs.getCount(); i++)
                {
                    String s = getOIDValue(FCertIDs.getCertID(i).getIssuerSerial().getIssuerRDN(), SBConstants.SB_CERT_OID_COMMON_NAME.Data);
                    if (s == "")
                        s = getOIDValue(FCertIDs.getCertID(i).getIssuerSerial().getIssuerRDN(), SBConstants.SB_CERT_OID_ORGANIZATION.Data);

                    if (s == "")
                        s = "<unknown>";

                    byte[] B = FCertIDs.getCertID(i).getIssuerSerial().getSerialNumber();
                    addSignCertItem(SBUtils.beautifyBinaryString(SBUtils.binaryToString(B), ' '), s, null);
                }
	}
	
	private void addSignCertItem(String serialNumber, String issuer, TElX509Certificate cert) {
		DefaultTableModel model = (DefaultTableModel)table.getModel();
		model.insertRow(model.getRowCount(), new Object[] {serialNumber, issuer});
	}

	private String getOIDValue(TElRelativeDistinguishedName RDN, byte[] S) {
        String t = "";
        int iCount = RDN.getCount();
        for (int i = 0; i < iCount; i++)
        {
            if (SBUtils.compareContent(RDN.getOID(i), S))
            {
                if (t != "")
                    t += " / ";

                t += SBStrUtils.utf8ToStr(RDN.getValue(i));
            }
        }
        return t;
	}

	private void clearSigningCertificatesTable() {
		((DefaultTableModel)table.getModel()).setNumRows(0);
	}

	public TElCustomCertStorage getCertStorage() {
		return FCertStorage;
	}

	public void setCertIDs(TElXMLCertIDList value) {
        FCertIDs = value;
        updateCertificates();
	}	
}
